#ifndef GEOMETRYFORMATOBJ_H
#define GEOMETRYFORMATOBJ_H

// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the COBJReader K-3D object, which reads Wavefront .obj files
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dobject.h>
#include <k3difileformat.h>
#include <k3digeometryreadformat.h>

///////////////////////////////////////////////////////////////////////////////
// COBJReader

class COBJReader : public k3dObject,
									public k3dIFileFormat,
									public k3dIGeometryReadFormat
{
public:
	// k3dIUnknown overrides ...
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIFileFormat overrides ...
	K3DFILEFORMATHANDLE GetFirstFileFormat();
	K3DFILEFORMATHANDLE GetNextFileFormat(K3DFILEFORMATHANDLE Handle);
	SDPCSTRING GetFileFormat(K3DFILEFORMATHANDLE Handle);
	sdpResult QueryCanHandle(SDPCSTRING FilePath, SDPCSTRING Format);

	// k3dIGeometryReadFormat overrides ...
	k3dIFileFormat* FileFormat();
	sdpResult PreRead(SDPCSTRING FilePath, SDPCSTRING Format);
	sdpResult ReadOptions(SDPCSTRING FilePath, SDPCSTRING Format);
	sdpResult ReadFile(SDPCSTRING FilePath, SDPCSTRING Format);
};

#endif // GEOMETRYFORMATOBJ_H
