#include "stdafx.h"
#include "geometryformatgeo.h"
#include "geometryfilter.h"


#include "cmfxstring.h"

///////////////////////////////////////////////////////////////
// k3dIUnknown overrides

sdpResult CGeometryFormatGEO::QueryInterface(const sdpIID& InterfaceID, void** Interface)
{
	if(sdpSupportInterface<sdpIUnknown>(static_cast<k3dIObject*>(this), InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIObject>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIGeometryReadFormat>(this, InterfaceID, Interface)) return SDP_S_OK;

	return SDP_E_NO_INTERFACE;
}


gulong CGeometryFormatGEO::AddRef()
{
	return sdpCOMAddRef(m_ReferenceCount);
}


gulong CGeometryFormatGEO::Release()
{
	return sdpCOMRelease(this, m_ReferenceCount);
}






///////////////////////////////////////////////////////////////
// k3dIGeometryFormat overrides

SDPCSTRING CGeometryFormatGEO::GetReadFilterString()
{
	return (SDPCSTRING)"GEO File (*.geo)|*.geo";
}


sdpResult CGeometryFormatGEO::QueryCanRead(SDPCSTRING FilePath)
{
	sdpString filepath = FilePath;

	filepath.tolower();
	if("geo" == filepath.right(3)) return SDP_S_OK;

	return SDP_S_FALSE;
}



sdpResult CGeometryFormatGEO::ReadFile(SDPCSTRING FilePath)
{
#pragma SDPPOSTIT(*** CGeometryFormatGEO::ReadFile())
/*
	sdpResult hr;

	LONG numpoints, pointnum;
	LONG i;

	CMfxString s;

	double coords[3];
	KHANDLE handle;

	CArray<KHANDLE, KHANDLE> pointarray;


	CFile file;
	if(!file.Open(FilePath, CFile::modeRead | CFile::shareExclusive))
		{
			m_IO->Error("Error opening .geo file", "Load .geo file:");
			KFAIL(SDP_E_FAIL);
		}

	m_GroupList->Create();
	m_Group->ObjectContext()->SetName("Untitled .geo object");

	CArchive ar(&file,CArchive::load);

	if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);

	if(strncmp(s, "3DG", 3) == 0)
		{
			if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
			numpoints = atol(s);

			pointarray.SetSize(numpoints);

			for(i = 0; i < numpoints; i++)
				{
					hr = m_GroupPointList->Create();
					if(SDP_S_OK == hr)
						{
							pointarray.SetAt(i, m_GroupPointList->GetHandle());

							if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
							coords[0] = atof(s);

							if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
							coords[1] = atof(s);

							if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
							coords[2] = atof(s);

							m_GroupPointLocation->SetOldXYZ(coords);
							m_GroupPointLocation->SetLocalXYZ(coords);
						}
				}


			if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
			numpoints = atol(s);
				{
					while(numpoints)
						{
							hr = m_GroupPolygonList->Create();
							if(SDP_S_OK == hr)
								{
									for(i = 0; i < numpoints; i++)
										{
											if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
											pointnum = atol(s);
											handle = pointarray.GetAt(pointnum);

											hr = m_GroupPolygon->AttachPointAfter(handle);
										}
								}

							if(s.ReadToken(ar) == FALSE) KFAIL(SDP_E_FAIL);
							if(s.ReadToken(ar) == FALSE) break;
							numpoints = atol(s);

						}
				}
		}
	else
		{
			m_IO->Error("File isn't a .geo file", "Load .geo file:");
			KFAIL(SDP_E_FAIL);
		}
*/
	return SDP_S_OK;
}

