/*
 * background.sl -- imager shader to put a solid background color behind
 *                  an image.
 *
 * DESCRIPTION:
 *   Puts a solid background color in all the pixels which do not contain
 *   foreground objects.
 * 
 * PARAMETERS:
 *   bgcolor - the color of the background
 *
 * AUTHOR: Larry Gritz
 *
 */

/* Modified for use as a standard K-3D shader by Timothy M. Shead, tshead@k-3d.com */


imager
k3d_background(color bgcolor = 1, background = 1)
{
	Ci += (1 - alpha) * (bgcolor * background);
	Oi = 1;
	alpha = 1;
}
