/** Name = ImageLayer Gradient **/
/** CreatedBy = Shead Data Processing **/

/** ObjectID = {58EA71C0-59FA-11d0-9C0D-444553540000} **/

/** zenith:Name = Zenith Color **/
/** zenith:HelpString = Sky color at the zenith (positive Y axis) **/

/** sky:Name = Sky Color **/
/** sky:HelpString = Sky color at the horizon **/

/** ground:Name = Ground Color **/
/** ground:HelpString = Ground color at the horizon **/

/** nadir:Name = Nadir Color **/
/** nadir:HelpString = Ground color at the nadir (negative Y axis) **/

/* Modified for use as a standard K-3D shader by Timothy M. Shead, tshead@k-3d.com */

surface k3d_imagelayergradient(color zenith = color(0, 0, 1); color sky = color(.5, .5, 1); color ground = color(.6, .6, .1); color nadir = color(0, 0, 0);
	)
{
	Oi = Os;

	if (v < 0.5)
		{
			Ci = Cs * mix(zenith, sky, v * 2.0);
		}
	else
		{
			Ci = Cs * mix(ground, nadir, (v - 0.5) * 2.0);
		}
}
