/** Name = Water Light **/
/** CreatedBy = Shead Data Processing **/

/** LightType = Distant **/
/** LightIntensityParameter = intensity **/
/** LightColorParameter = lightcolor **/

/** intensity:Name = Intensity **/
/** intensity:HelpString = Light intensity **/

/** lightcolor:Name = Light Color **/
/** lightcolor:HelpString = Light color **/

/* Modified for use as a standard K-3D shader by Timothy M. Shead, tshead@k-3d.com */


#include "k3d_noises.h"

light k3d_waterlight(float intensity = 1; float phase = 0.0; float spread = 15.0; color lightcolor = color(0.2, 0.6, 0.9); point from = point "shader"(0, 0, 0);
										 point to = point "shader"(0, -1, 0);)
{
	uniform point w1 = point "world"(100, 0, 200);
	uniform point w2 = point "world"(-300, 0, 400);
	uniform point w3 = point "world"(-500, 0, -600);
	uniform point w4 = point "world"(700, 0, -800);

	solar(to - from, radians(spread))
	{
		point Pworld = transform("world", Ps);

		float caustic = 1.0;

		caustic += .2 * sin(3.2 * length(Pworld - w1) + phase);
		caustic += .2 * sin(1.24 * length(Pworld - w2) + phase);
		caustic += .2 * sin(2.3 * length(Pworld - w3) + phase);
		caustic += .2 * sin(1.53 * length(Pworld - w4) + phase);

		Cl = caustic * intensity * lightcolor;
	}
}
