/** Name = Windy Waves **/
/** CreatedBy = F. Kenton Musgrave **/
/** History1 = Created by F. Kenton Musgrave **/
/** History2 = Translation to Shading Language by Larry Gritz in Apr 94 **/
/** History3 = Modified for K-3D by Shead Data Processing **/

/** Km:Name = Wave Amplitude **/
/** Km:HelpString = Overall amplitude of the waves **/

/** txtscale:Name = Wave Frequency **/
/** txtscale:HelpString = Overall frequency of the waves **/

/** windfreq:Name = Wind Frequency **/
/** windfreq:HelpString = Frequency of wave variations caused by wind **/

/** windamp:Name = Wind Amplitude **/
/** windamp:HelpString = Amplitude of variations caused by the wind **/

/** minwind:Name = Minimum Wind **/
/** minwind:HelpString = Minimum amount of variation caused by the wind **/

/* Modified for use as a standard K-3D shader by Timothy M. Shead, tshead@k-3d.com */


#define snoise(Pt) (2*noise(Pt) - 1)

displacement k3d_windywave(float Km = 0.1; float txtscale = 1; float windfreq = 0.5; float windamp = 1; float minwind = 0.3)
{
	float offset;
	point PP;
	float wind;
	float turb, a, i;

	PP = txtscale * windfreq * transform("shader", P);

	offset = Km * (snoise(PP) + 0.5 * snoise(2 * PP));

	turb = 0;
	a = 1;
	PP *= 8;
	for (i = 0; i < 4; i += 1)
		{
			turb += abs(a * snoise(PP));
			PP *= 2;
			a /= 2;
		}
	wind = minwind + windamp * turb;

/*  P += wind * offset * normalize(N); */
	N = calculatenormal(P + wind * offset * normalize(N));
}
