#ifndef K3DIANIMATE_H
#define K3DIANIMATE_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIAnimate interface, which is used to update the state of a K-3D document based on the current time
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

class k3dIAnimate : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual sdpResult PreAnimate() = 0;
	virtual sdpResult PushAnimate() = 0;
	virtual sdpResult Animate() = 0;
	virtual sdpResult PopAnimate() = 0;
	virtual sdpResult PostAnimate() = 0;
};

#endif // K3DIANIMATE_H
