#ifndef K3DIBITMAPSERVER_H
#define K3DIBITMAPSERVER_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIBitmapServer interface, for objects that connect to an object that supports k3dIBitmap
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>
#include <k3dibitmap.h>

/// K-3D interface for objects that connect to a k3dIBitmap interface
class k3dIBitmapServer : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	/// Returns a pointer to the current bitmap object
	virtual k3dIBitmap* GetBitmap() = 0;

	/// Called to set the bitmap object that this object should point to
	virtual sdpResult SetBitmap(k3dIBitmap*) = 0;
};

#endif // K3DIBITMAPSERVER_H
