#ifndef K3DIEDITORENGINE_H
#define K3DIEDITORENGINE_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIEditorEngine interface, which encapsulates the editor-mode rendering engine
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class declarations ...
class k3dICamera;

class k3dIEditorEngine : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

public:
	virtual k3dICamera* Camera() = 0;
	virtual sdpResult EditorQuerySolid() = 0;
	virtual sdpResult EditorQueryShaded() = 0;
	virtual sdpResult EditorQueryTextured() = 0;
	virtual sdpResult EditorQueryOrientation() = 0;
	virtual sdpResult EditorQueryNormals() = 0;
	virtual gulong EditorQueryWireframePatchDivisions() = 0;
	virtual gulong EditorQuerySolidPatchDivisions() = 0;
};

#endif // K3DIEDITORENGINE_H
