#ifndef K3DIEVENTCLIENT_H
#define K3DIEVENTCLIENT_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIEventClient interface, implemented by objects that wish to be notified of object-to-object events
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>

// Forward class declarations
class k3dIObject;

/// Declares the OnEvent() method for objects that wish to be notified of custom events
class k3dIEventClient : public virtual sdpIUnknown
{
public:
	/// Stores the sdpCom Interface ID for this interface
	static const sdpIID iid;

	/// Called by an event server when the given event is signalled
	virtual sdpResult OnEvent(k3dIObject* Object, SDPCSTRING Event, gulong ClientData) = 0;
};

#endif // K3DIEVENTCLIENT_H
