#ifndef K3DINURBSCURVESERVER_H
#define K3DINURBSCURVESERVER_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dINURBSCurveServer interface, which encapsulates a collection of NURBS curves
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dinurbscurve.h>

class k3dINURBSCurveServer : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual gulong GetNURBSCurveCount() = 0;
	virtual K3DNURBSCURVEHANDLE GetFirstNURBSCurve() = 0;
	virtual K3DNURBSCURVEHANDLE GetNextNURBSCurve(K3DNURBSCURVEHANDLE Curve) = 0;
	virtual k3dINURBSCurve* GetNURBSCurve(K3DNURBSCURVEHANDLE Curve) = 0;
	virtual sdpResult AddNURBSCurve(k3dINURBSCurve* Curve) = 0;
	virtual sdpResult RemoveNURBSCurve(k3dINURBSCurve* Curve) = 0;
};

#endif // K3DINURBSCURVESERVER_H
