#ifndef K3DIPOLYGONSERVER_H
#define K3DIPOLYGONSERVER_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIPolygonServer interface, which encapsulates a collection of k3dIPolygon objects
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dipolygon.h>

class k3dIPolygonServer : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual gulong GetPolygonCount() = 0;
	virtual K3DPOLYGONHANDLE GetFirstPolygon() = 0;
	virtual K3DPOLYGONHANDLE GetNextPolygon(K3DPOLYGONHANDLE Polygon) = 0;
	virtual k3dIPolygon* GetPolygon(K3DPOLYGONHANDLE Polygon) = 0;
	virtual sdpResult AddPolygon(k3dIPolygon* Polygon) = 0;
	virtual sdpResult RemovePolygon(k3dIPolygon* Polygon) = 0;
};

#endif // K3DIPOLYGONSERVER_H
