#ifndef K3DIRITEXTURE_H
#define K3DIRITEXTURE_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dIRiTexture interface, implemented by objects that can act as a texture source when rendering Ri mode graphics
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpcom.h>
#include <k3dicamera.h>
#include <k3diriengine.h>

class k3dIRiTexture : public virtual sdpIUnknown
{
public:
	static const sdpIID iid;

	virtual sdpResult RiTextureStartJob(k3dIRenderJob* Job, k3dIRiEngine* Engine) = 0;
	virtual sdpResult RiTexturePreRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine) = 0;
	virtual sdpResult RiTextureFinishJob(k3dIRenderJob* Job, k3dIRiEngine* Engine) = 0;
	
	virtual SDPCSTRING RiTexturePath(k3dIRenderFrame* Frame, k3dIRiEngine* Engine) = 0;
};

#endif // K3DIRITEXTURE_H
