#ifndef K3DPERSISTOBJECT_H
#define K3DPERSISTOBJECT_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dPersistObject class, which encapsulates a K-3D object capable of automatically serializing itself
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3duserobject.h>
#include <k3danimate.h>
#include <k3dtimeserver.h>
#include <k3dipersist.h>

class k3dPersistObject : public k3dUserObject,
											public k3dAnimate,
											public k3dTimeServer,
											public k3dIPersist
{
public:
	k3dPersistObject();
	virtual ~k3dPersistObject();

	// k3dIPersist overrides
	sdpResult InitNew();
	sdpResult Load(sdpXmlIElement* Element);
	sdpResult LoadComplete();
	sdpResult Save(sdpXmlIElement* Element, k3dIDependencies* Dependencies);
	sdpResult SaveComplete();


	// Helper functions
	sdpResult SaveObjects(sdpXmlIElement* Element, k3dIDependencies* Dependencies);
	sdpResult LoadObjects(sdpXmlIElement* Element);
	sdpResult BindObjects();

	sdpResult SaveVariables(sdpXmlIElement* Element, k3dIDependencies* Dependencies);
	sdpResult LoadVariables(sdpXmlIElement* Element);
};

#endif // K3DPERSISTOBJECT_H
