#ifndef K3DRIRENDER_H
#define K3DRIRENDER_H

// K-3D
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the k3dRiRender class, which provides a default implementation of k3dIRiRender
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dirirender.h>

class k3dRiRender : public k3dIRiRender
{
public:
	sdpResult RiStartJob(k3dIRenderJob* Job, k3dIRiEngine* Engine);
	sdpResult RiSetSolid(bool Solid);
	sdpResult RiPreRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiPushRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiPushChildRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiPopChildRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiPopRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiPostRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine);
	sdpResult RiFinishJob(k3dIRenderJob* Job, k3dIRiEngine* Engine);
	
protected:
	bool m_RiSolid;
};

#endif // K3DRIRENDER_H
