// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements the k3dRiRender class, which provides a default implementation of k3dIRiRender
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3drirender.h>
#include <k3diriengine.h>

sdpResult k3dRiRender::RiStartJob(k3dIRenderJob* Job, k3dIRiEngine* Engine)
{
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiSetSolid(bool Solid)
{
	m_RiSolid = Solid;
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPreRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPushRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	Engine->RiComment("Starting object");
	Engine->RiNewline();
	Engine->RiAttributeBegin();
	
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPushChildRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	Engine->RiComment("Starting child");
	Engine->RiNewline();
	Engine->RiAttributeBegin();

	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPopChildRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	Engine->RiAttributeEnd();
	Engine->RiNewline();
	Engine->RiNewline();

	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPopRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	Engine->RiAttributeEnd();
	Engine->RiNewline();
	Engine->RiNewline();
	
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiPostRender(k3dIRenderFrame* Frame, k3dIRiEngine* Engine)
{
	return SDP_S_OK;
}

sdpResult k3dRiRender::RiFinishJob(k3dIRenderJob* Job, k3dIRiEngine* Engine)
{
	return SDP_S_OK;
}


