#ifndef PARTICLEEMITTER_H
#define PARTICLEEMITTER_H

// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the CParticleEmitter class, which emits CParticleBurst particles
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dtransformobject.h>
#include <k3dlocationserver.h>

class CParticleEmitter : public k3dTransformObject,
												 public k3dLocationServer
{
public:
	CParticleEmitter();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult QueryRenameObject();
	sdpResult QueryDeleteObject();

	// k3dIEditorRender overrides
	sdpResult EditorRender(k3dIEditorEngine* Engine);

	// k3dIPersist overrides
	sdpResult Save(sdpXmlIElement* Element, k3dIDependencies* Dependencies);
	sdpResult Load(sdpXmlIElement* Element);
};

#endif // PARTICLEEMITTER_H
