
#include "resource.h"

// Forward class references
class CBevel;
class CBevelSheet;



/////////////////////////////////////////////////////////////////////////////
// CBevelPage dialog

class CBevelPage : public KPage
{
public:
	CBevelPage(CBevelSheet* Sheet);

	CBevelSheet* m_Sheet;

	//{{AFX_DATA(CBevelPage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBevelPage)
	//}}AFX_VIRTUAL

protected:
	// Generated message map functions
	//{{AFX_MSG(CBevelPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnKillfocusWidth();
	afx_msg void OnKillfocusHeight();
	afx_msg void OnKillfocusSegments();
	afx_msg void OnFaces();
	afx_msg void OnBevels();
	afx_msg void OnPercentage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////
// CBevelSheet

class CBevelSheet : public KPrimSheet
{
public:
	CBevelSheet(CBevel* Object);
	~CBevelSheet();

	bool Create();
	void OnHelp();

	CBevel* m_Object;

	CBevelPage* m_BevelPage;

	//{{AFX_DATA(CBevelSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBevelSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBevelSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CBevel

class CBevel : public k3dPrimTool
{
public:
	CBevel();
	~CBevel();

	void GetGroupInfo(k3dIGroup* Group, gulong& SelectedPoints, gulong& SelectedPolys, gulong& NewPoints, gulong& NewPolys);
	void CreateGroupGeometry(k3dIGroup* Group, gulong SelectedPoints, gulong SelectedPolys, gulong NewPoints, gulong NewPolys);
	void CalculateGroupGeometry(k3dIGroup* Group, gulong SelectedPoints, gulong SelectedPolys, gulong NewPoints, gulong NewPolys);
	void CalculateGroupPercentage(k3dIGroup* Group, gulong SelectedPoints, gulong SelectedPolys, gulong NewPoints, gulong NewPolys);
	void CalculateGroupNormal(k3dIGroup* Group, gulong SelectedPoints, gulong SelectedPolys, gulong NewPoints, gulong NewPolys);

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult EditObject();

	// k3dIDocumentEventClient overrides
	sdpResult OnUndo(k3dIObject*);
	sdpResult OnSelectChanged();

	// k3dIUserEventClient overrides
	sdpResult OnLButtonStartDrag(long, long, long);
	sdpResult OnLButtonDrag(long, long, long);
	sdpResult OnLButtonEndDrag(long, long, long);
	
	// Data
	double m_Width;
	double m_Height;
	long m_Segments;
	bool m_CreateFaces;
	bool m_CreateBevels;
	bool m_PercentageWidth;
	double m_Sensitivity;

	CBevelSheet* m_Sheet;
};





