
#include "resource.h"

// Forward class references
class CBridge;
class CBridgeSheet;




/////////////////////////////////////////////////////////////////////////////
// CBridgePage dialog

class CBridgePage : public KPage
{
public:
	CBridgePage(CBridgeSheet* Sheet);

	CBridgeSheet* m_Sheet;

	//{{AFX_DATA(CBridgePage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBridgePage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBridgePage)
	virtual BOOL OnInitDialog();
	afx_msg void OnFixedsize();
	afx_msg void OnKillfocusPointcount();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////
// CBridgeSheet

class CBridgeSheet : public KPrimSheet
{
public:
	CBridgeSheet(CBridge* Object);
	~CBridgeSheet();

	bool Create();
	void OnHelp();

	CBridge* m_Object;

	CBridgePage* m_BridgePage;

	//{{AFX_DATA(CBridgeSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CBridgeSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBridgeSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CBridge

class CBridge : public k3dPrimTool,
								public k3dOpenGLRender
{
public:
	CBridge();
	~CBridge();

	void AddPoint(k3dIPoint* Point);
	void CreateBridgePolygon();
	void OnModify();

	void KillAll();				// Deletes all new geometry
	void CreateAll();			// Makes new geometry permanent

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	//k3dIObject overrides
	sdpResult SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context);
	sdpResult EditObject();

	//k3dIDocumentEventClient overrides
	sdpResult OnUndo(k3dIObject*);
	
	// k3dIUserEventClient overrides
	sdpResult OnLButtonClick(long, long, long);
	sdpResult OnRButtonClick(long, long, long);

	// k3dIOpenGLRender overrides
	sdpResult OpenGLRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine);

	CBridgeSheet* m_Sheet;

	bool m_FixedPointCount;
	long m_PointCount;

	KPointArray m_PointArray;

	k3dIGroup* m_Group;
};


