#include "stdafx.h"
#include "tlbffdeform.h"
#include "toollib.h"





/////////////////////////////////////////////////////////////////////////////
// CFFDeformPage property page

CFFDeformPage::CFFDeformPage(CFFDeformSheet* Sheet)
  : KPage(IDD, Sheet, "FFDeform")
{
	//{{AFX_DATA_INIT(CFFDeformPage)
	//}}AFX_DATA_INIT

	m_Sheet = Sheet;
}




BEGIN_MESSAGE_MAP(CFFDeformPage, KPage)
	//{{AFX_MSG_MAP(CFFDeformPage)
	ON_BN_CLICKED(IDC_ACTIVEADD, OnActiveadd)
	ON_BN_CLICKED(IDC_ACTIVEREMOVE, OnActiveremove)
	ON_BN_CLICKED(IDC_ACTIVEREMOVEALL, OnActiveremoveall)
	ON_BN_CLICKED(IDC_ACTIVESELECT, OnActiveselect)
	ON_BN_CLICKED(IDC_GRIDADD, OnGridadd)
	ON_BN_CLICKED(IDC_GRIDREMOVE, OnGridremove)
	ON_BN_CLICKED(IDC_GRIDREMOVEALL, OnGridremoveall)
	ON_BN_CLICKED(IDC_GRIDSELECT, OnGridselect)
	ON_BN_CLICKED(IDC_BONES, OnBones)
	ON_BN_CLICKED(IDC_MAGNETS, OnMagnets)
	ON_EN_k3dILLFOCUS(IDC_RANGE, OnKillfocusRange)
	ON_EN_k3dILLFOCUS(IDC_STRENGTH, OnKillfocusStrength)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	ON_BN_CLICKED(IDC_CUSTOMSTRENGTH, OnCustomstrength)
	ON_BN_CLICKED(IDC_AUTOUPDATE, OnAutoupdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFFDeformPage message handlers

BOOL CFFDeformPage::OnInitDialog()
{
	KPage::OnInitDialog();

	k3dSetDouble(k3dIChannel::DATA_SCALAR, GetDlgItem(IDC_STRENGTH)->m_hWnd, m_Sheet->m_Object->m_Strength);
	k3dSetDouble(k3dIChannel::DATA_DISTANCE, GetDlgItem(IDC_RANGE)->m_hWnd, m_Sheet->m_Object->m_Range);
	CheckDlgButton(IDC_CUSTOMSTRENGTH, m_Sheet->m_Object->m_CustomStrength);
	CheckDlgButton(IDC_AUTOUPDATE, m_Sheet->m_Object->m_AutoUpdate);

	if(CFFDeform::BONES == m_Sheet->m_Object->m_Type)
		{
			CheckRadioButton(IDC_BONES, IDC_MAGNETS, IDC_BONES);
		}
	else if(CFFDeform::MAGNETS == m_Sheet->m_Object->m_Type)
		{
			CheckRadioButton(IDC_BONES, IDC_MAGNETS, IDC_MAGNETS);
		}

	m_Sheet->m_Object->m_Strengthfalloff->Attach(GetDlgItem(IDC_STRENGTHFALLOFF)->m_hWnd);

	OnUpdateNumbers();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CFFDeformPage::OnUpdateNumbers()
{
	k3dSetLong(GetDlgItem(IDC_ACTIVEPOINTS)->m_hWnd, m_Sheet->m_Object->m_ActivePoints.GetCount());
	k3dSetLong(GetDlgItem(IDC_GRIDPOINTS)->m_hWnd, m_Sheet->m_Object->m_GridPoints.GetCount());
}



void CFFDeformPage::OnActiveadd()
{
	sdpResult hr;
	KHANDLE handle;
	double coords[3];
	SFFDeformActivePoint activepoint;

	CList<SFFDeformActivePoint, SFFDeformActivePoint> newlist;

	POSITION position;

	m_Sheet->m_Object->m_PointMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PointMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PointMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PointMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PointMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Point->GetHandle();
			m_Sheet->m_Object->m_PointLocation->GetLocalXYZ(coords);

			position = m_Sheet->m_Object->m_ActivePoints.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_ActivePoints.GetNext(position).m_PointHandle == handle)
						{
							continue;
						}
				}

			activepoint.m_PointHandle = handle;
			activepoint.m_OriginalX = coords[0];
			activepoint.m_OriginalY = coords[1];
			activepoint.m_OriginalZ = coords[2];

			newlist.AddTail(activepoint);
		}

	m_Sheet->m_Object->m_ActivePoints.AddTail(&newlist);
	newlist.RemoveAll();

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnActiveremove()
{
	sdpResult hr;
	KHANDLE handle;

	POSITION position;

	m_Sheet->m_Object->m_PointMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PointMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PointMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PointMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PointMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Point->GetHandle();

			position = m_Sheet->m_Object->m_ActivePoints.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_ActivePoints.GetAt(position).m_PointHandle == handle)
						{
							m_Sheet->m_Object->m_ActivePoints.RemoveAt(position);
							break;
						}
					m_Sheet->m_Object->m_ActivePoints.GetNext(position);
				}
		}

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnActiveremoveall()
{
	m_Sheet->m_Object->m_ActivePoints.RemoveAll();

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnActiveselect()
{
	POSITION position;
	sdpResult hr;

	position = m_Sheet->m_Object->m_ActivePoints.GetHeadPosition();
	while(position)
		{
			hr = m_Sheet->m_Object->m_PointList->SetHandle(m_Sheet->m_Object->m_ActivePoints.GetNext(position).m_PointHandle);
			if(sdpSucceeded(hr))
				{
					m_Sheet->m_Object->m_Point->SetSelected(TRUE);
					m_Sheet->m_Object->m_Point->SetShow(TRUE);
				}
		}
	OnModify();
}

void CFFDeformPage::OnGridadd()
{
	sdpResult hr;
	KHANDLE handle;
	double coords[3];
	SFFDeformGridPoint gridpoint;

	CList<SFFDeformGridPoint, SFFDeformGridPoint> newlist;
	CList<KHANDLE, KHANDLE> newpolylist;

	POSITION position;

	m_Sheet->m_Object->m_PointMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PointMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PointMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PointMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PointMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Point->GetHandle();
			m_Sheet->m_Object->m_PointLocation->GetLocalXYZ(coords);

			position = m_Sheet->m_Object->m_GridPoints.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_GridPoints.GetNext(position).m_PointHandle == handle)
						{
							continue;
						}
				}

			gridpoint.m_PointHandle = handle;
			gridpoint.m_OriginalX = coords[0];
			gridpoint.m_OriginalY = coords[1];
			gridpoint.m_OriginalZ = coords[2];

			newlist.AddTail(gridpoint);
		}

	m_Sheet->m_Object->m_GridPoints.AddTail(&newlist);
	newlist.RemoveAll();


	m_Sheet->m_Object->m_PolygonMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PolygonMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PolygonMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PolygonMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PolygonMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Polygon->GetHandle();

			position = m_Sheet->m_Object->m_GridPolys.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_GridPolys.GetNext(position) == handle)
						{
							continue;
						}
				}

			m_Sheet->m_Object->m_Polygon->SetRenderable(FALSE);

			newpolylist.AddTail(handle);
		}

	m_Sheet->m_Object->m_GridPolys.AddTail(&newpolylist);
	newpolylist.RemoveAll();

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnGridremove()
{
	sdpResult hr;
	KHANDLE handle;

	POSITION position;

	m_Sheet->m_Object->m_PointMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PointMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PointMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PointMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PointMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Point->GetHandle();

			position = m_Sheet->m_Object->m_GridPoints.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_GridPoints.GetAt(position).m_PointHandle == handle)
						{
							m_Sheet->m_Object->m_GridPoints.RemoveAt(position);
							break;
						}
					m_Sheet->m_Object->m_GridPoints.GetNext(position);
				}
		}



	m_Sheet->m_Object->m_PolygonMatchList->ClearCriteria();
	m_Sheet->m_Object->m_PolygonMatchList->SetShowCriteria(TRUE, TRUE);
	m_Sheet->m_Object->m_PolygonMatchList->SetSelectedCriteria(TRUE, TRUE);

	for(hr = m_Sheet->m_Object->m_PolygonMatchList->SetFirstMatch(); SDP_S_OK == hr; hr = m_Sheet->m_Object->m_PolygonMatchList->SetNextMatch())
		{
			handle = m_Sheet->m_Object->m_Polygon->GetHandle();

			position = m_Sheet->m_Object->m_GridPolys.GetHeadPosition();
			while(position)
				{
					if(m_Sheet->m_Object->m_GridPolys.GetAt(position) == handle)
						{
							m_Sheet->m_Object->m_PolygonList->SetHandle(handle);
							m_Sheet->m_Object->m_Polygon->SetRenderable(TRUE);

							m_Sheet->m_Object->m_GridPolys.RemoveAt(position);
							break;
						}
					m_Sheet->m_Object->m_GridPolys.GetNext(position);
				}
		}

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnGridremoveall()
{
	m_Sheet->m_Object->m_GridPoints.RemoveAll();

	for(POSITION position = m_Sheet->m_Object->m_GridPolys.GetHeadPosition(); position; m_Sheet->m_Object->m_GridPolys.GetNext(position))
		{
			m_Sheet->m_Object->m_PolygonList->SetHandle(m_Sheet->m_Object->m_GridPolys.GetAt(position));
			m_Sheet->m_Object->m_Polygon->SetRenderable(TRUE);
		}

	m_Sheet->m_Object->m_GridPolys.RemoveAll();

	OnUpdateNumbers();
	OnModify();
}

void CFFDeformPage::OnGridselect()
{
	POSITION position;
	sdpResult hr;

	position = m_Sheet->m_Object->m_GridPoints.GetHeadPosition();
	while(position)
		{
			hr = m_Sheet->m_Object->m_PointList->SetHandle(m_Sheet->m_Object->m_GridPoints.GetNext(position).m_PointHandle);
			if(sdpSucceeded(hr))
				{
					m_Sheet->m_Object->m_Point->SetSelected(TRUE);
					m_Sheet->m_Object->m_Point->SetShow(TRUE);
				}
		}
	OnModify();
}

void CFFDeformPage::OnBones()
{
	m_Sheet->m_Object->m_Type = CFFDeform::BONES;
	OnModify();
}

void CFFDeformPage::OnMagnets()
{
	m_Sheet->m_Object->m_Type = CFFDeform::MAGNETS;
	OnModify();
}

void CFFDeformPage::OnKillfocusRange()
{
	KValidateDouble(k3dIChannel::DATA_DISTANCE, GetDlgItem(IDC_RANGE)->m_hWnd, m_Sheet->m_Object->m_Range, 0.000000001, DBL_MAX);
	OnModify();
}

void CFFDeformPage::OnKillfocusStrength()
{
	KUpdateDouble(k3dIChannel::DATA_SCALAR, GetDlgItem(IDC_STRENGTH)->m_hWnd, m_Sheet->m_Object->m_Strength);
	OnModify();
}

void CFFDeformPage::OnReset()
{
	m_Sheet->m_Object->OnReset();
	OnModify();
}

void CFFDeformPage::OnUpdate()
{
	if(m_Sheet->m_Object->m_ActivePoints.GetCount() && m_Sheet->m_Object->m_GridPoints.GetCount())
		{
			OnModify();
		}
	else
		{
			m_Sheet->m_Object->m_IO->Message("Must select both active and grid points before updating","FFDeform:");
		}
}


void CFFDeformPage::OnCustomstrength()
{
	m_Sheet->m_Object->m_CustomStrength = IsDlgButtonChecked(IDC_CUSTOMSTRENGTH) ? TRUE : FALSE;
	OnModify();
}

void CFFDeformPage::OnAutoupdate()
{
	m_Sheet->m_Object->m_AutoUpdate = IsDlgButtonChecked(IDC_AUTOUPDATE) ? TRUE : FALSE;
	OnModify();
}


////////////////////////////////////////////////////////////////////////////
// CFFDeformSheet

CFFDeformSheet::CFFDeformSheet(CFFDeform* Object)
: KSheet(Object, theApp.m_hInstance, "FFDeform", VERTICAL, "FFDeform", TRUE)
{
	m_FFDeformPage = NULL;
	m_Object = Object;
}


CFFDeformSheet::~CFFDeformSheet()
{
	m_Object->m_Sheet = NULL;
}



bool CFFDeformSheet::Create()
{
	m_FFDeformPage = new CFFDeformPage(this);

	if(m_FFDeformPage)
		{
			AddPage(m_FFDeformPage);

			Create(IDD);
			return TRUE;
		}

	KFAIL(FALSE);
}


BEGIN_MESSAGE_MAP(CFFDeformSheet, KSheet)
	//{{AFX_MSG_MAP(CFFDeformSheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



///////////////////////////////////////////////////////////////////////////////////
// CFFDeform

CFFDeform::CFFDeform() : k3dTool()
{
	m_Sheet = NULL;

	m_Strength = 1.0;
	m_Range = 10.0;
	m_Type = BONES;

	m_CustomStrength = FALSE;
	m_AutoUpdate = TRUE;
}


CFFDeform::~CFFDeform()
{
	for(POSITION position = m_GridPolys.GetHeadPosition(); position; m_GridPolys.GetNext(position))
		{
			m_PolygonList->SetHandle(m_GridPolys.GetAt(position));
			m_Polygon->SetRenderable(TRUE);
		}

	if(m_Sheet)
		m_Sheet->DestroyWindow();
}



///////////////////////////////////////////////////////////////
// k3dIUnknown overrides

sdpResult CFFDeform::QueryInterface(const sdpIID& InterfaceID, void** Interface)
{
	if(sdpSupportInterface<sdpIUnknown>(static_cast<k3dIObject*>(this), InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIObject>(this, InterfaceID, Interface)) return SDP_S_OK;

	if(sdpSupportInterface<k3dIDocumentEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIUserEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIAnimate>(this, InterfaceID, Interface)) return SDP_S_OK;

	return SDP_E_NO_INTERFACE;
}


gulong CFFDeform::AddRef()
{
	return sdpComAddRef(m_ReferenceCount);
}


gulong CFFDeform::Release()
{
	return sdpComRelease(this, m_ReferenceCount);
}




///////////////////////////////////////////////////////////////
// k3dIObject overrides

sdpResult CFFDeform::SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context)
{
	if(sdpFailed(k3dTool::SetObjectContext(Server, Context))) KFAIL(SDP_E_FAIL);

	return SDP_S_OK;
}


sdpResult CFFDeform::EditObject()
{
	if(sdpFailed(m_Strengthfalloff.CreateScalar(m_Document, "FFDeformer strength falloff", 0.0, TRUE, FALSE, 0.0, 1.0, "Distance", "Strength", k3dIChannel::DATA_SCALAR, FALSE, this, m_ObjectContext->ObjectID()))) KFAIL(SDP_E_FAIL);
	AddObject(&m_Strengthfalloff);
	m_Strengthfalloff->SetLinear1(1.0, 0.0);

	if(!KOpenDialog(m_Sheet, this)) KFAIL(SDP_E_FAIL);
	return SDP_S_OK;
}


//////////////////////////////////////////////////////////////////
// k3dIAnimate overrides

sdpResult CFFDeform::PostAnimate()
{
	if(m_AutoUpdate)
		{
			OnModifyGeometry();
		}

	return SDP_S_OK;
}




///////////////////////////////////////////////////////////////
// k3dIDocumentEventClient overrides

sdpResult CFFDeform::OnUndo(k3dIObject* Sender)
{
	m_Sheet->m_FFDeformPage->OnReset();
	OnModify();

	return SDP_S_OK;
}


sdpResult CFFDeform::OnPointsDeparting()
{
	sdpResult hr;
	KHANDLE handle;
	POSITION position;

	CList<SFFDeformActivePoint, SFFDeformActivePoint> newactivelist;
	CList<SFFDeformGridPoint, SFFDeformGridPoint> newgridlist;


	k3dIPoint* point;

	hr = m_Document->CreateObject(KPointEnumerator, IID_k3dIList, FALSE, FALSE, FALSE, (void**)&pointlist);
	if(sdpSucceeded(hr))
		{
			hr = pointlist->QueryInterface(IID_k3dIPoint, (void**)&point);
			if(sdpSucceeded(hr))
				{
					for(position = m_ActivePoints.GetHeadPosition(); position; m_ActivePoints.GetNext(position))
						{
							handle = m_ActivePoints.GetAt(position).m_PointHandle;

							for(hr = pointlist->SetFirst(); SDP_S_OK == hr; hr = pointlist->SetNext())
								{
									if(point->GetHandle() == handle)
										{
											newactivelist.AddTail(m_ActivePoints.GetAt(position));
											break;
										}
								}
						}

					m_ActivePoints.RemoveAll();
					m_ActivePoints.AddTail(&newactivelist);
					newactivelist.RemoveAll();

					point->Release();
				}
			pointlist->Release();
		}

	hr = m_Document->CreateObject(KPointEnumerator, IID_k3dIList, FALSE, FALSE, FALSE, (void**)&pointlist);
	if(sdpSucceeded(hr))
		{
			hr = pointlist->QueryInterface(IID_k3dIPoint, (void**)&point);
			if(sdpSucceeded(hr))
				{
					for(position = m_GridPoints.GetHeadPosition(); position; m_GridPoints.GetNext(position))
						{
							handle = m_GridPoints.GetAt(position).m_PointHandle;

							for(hr = pointlist->SetFirst(); SDP_S_OK == hr; hr = pointlist->SetNext())
								{
									if(point->GetHandle() == handle)
										{
											newgridlist.AddTail(m_GridPoints.GetAt(position));
											break;
										}
								}
						}

					m_GridPoints.RemoveAll();
					m_GridPoints.AddTail(&newgridlist);
					newgridlist.RemoveAll();

					point->Release();
				}
			pointlist->Release();
		}

	m_Sheet->m_FFDeformPage->OnUpdateNumbers();
	OnModify();

	return SDP_S_OK;

}




sdpResult CFFDeform::OnPolygonsDeparting()
{
	sdpResult hr;
	KHANDLE handle;
	POSITION position;

	CList<KHANDLE, KHANDLE> newlist;


	k3dIPolygon* polygon;

	hr = m_Document->CreateObject(KPolygonEnumerator, IID_k3dIList, FALSE, FALSE, FALSE, (void**)&polygonlist);
	if(sdpSucceeded(hr))
		{
			hr = polygonlist->QueryInterface(IID_k3dIPolygon, (void**)&polygon);
			if(sdpSucceeded(hr))
				{
					for(position = m_GridPolys.GetHeadPosition(); position; m_GridPolys.GetNext(position))
						{
							handle = m_GridPolys.GetAt(position);

							for(hr = polygonlist->SetFirst(); SDP_S_OK == hr; hr = polygonlist->SetNext())
								{
									if(polygon->GetHandle() == handle)
										{
											newlist.AddTail(handle);
											break;
										}
								}
						}

					m_GridPolys.RemoveAll();
					m_GridPolys.AddTail(&newlist);
					newlist.RemoveAll();

					polygon->Release();
				}
			polygonlist->Release();
		}

	m_Sheet->m_FFDeformPage->OnUpdateNumbers();
	OnModify();

	return SDP_S_OK;
}



void CFFDeformSheet::OnHelp()
{
	m_Object->StandardHelp("tools", "ffdeform.html");
}



/////////////////////////////////////////////////////////////////////////////
// CFFDeform message handlers

void CFFDeform::OnModify()
{
	// Skip the k3dTool implementation ...
	KUserObject::OnModify();
}


void CFFDeform::OnModifyGeometry()
{
	POSITION position1, position2;
	double coords1[3], coords2[3];
	double range;
	double dist, distx, disty, distz;
	double strength;
	SFFDeformActivePoint activepoint;
	SFFDeformGridPoint gridpoint;

	range = m_Range * m_Range;

	if(BONES == m_Type)
		{
			// Calculate & store grid point deltas
			for(position1 = m_GridPoints.GetHeadPosition(); position1; m_GridPoints.GetNext(position1))
				{
					gridpoint = m_GridPoints.GetAt(position1);

					m_PointList->SetHandle(gridpoint.m_PointHandle);
					m_PointLocation->GetLocalXYZ(coords1);
					gridpoint.m_DX = (coords1[0] - gridpoint.m_OriginalX);
					gridpoint.m_DY = (coords1[1] - gridpoint.m_OriginalY);
					gridpoint.m_DZ = (coords1[2] - gridpoint.m_OriginalZ);

					m_GridPoints.GetAt(position1) = gridpoint;
				}

			// Enumerate active points
			for(position2 = m_ActivePoints.GetHeadPosition(); position2; m_ActivePoints.GetNext(position2))
				{
					activepoint = m_ActivePoints.GetAt(position2);
					coords2[0] = activepoint.m_OriginalX;
					coords2[1] = activepoint.m_OriginalY;
					coords2[2] = activepoint.m_OriginalZ;

					m_PointList->SetHandle(activepoint.m_PointHandle);

					// Enumerate grid points
					for(position1 = m_GridPoints.GetHeadPosition(); position1; m_GridPoints.GetNext(position1))
						{
							gridpoint = m_GridPoints.GetAt(position1);

							distx = gridpoint.m_OriginalX - activepoint.m_OriginalX;
							disty = gridpoint.m_OriginalY - activepoint.m_OriginalY;
							distz = gridpoint.m_OriginalZ - activepoint.m_OriginalZ;

							dist = distx * distx + disty * disty + distz * distz;
							if(dist > range) continue;

							strength = sqrt(dist) / m_Range;
							if(m_CustomStrength)
								{
									strength = m_Strengthfalloff->GetValue1(strength, .001) * m_Strength;
								}
							else
								{
									strength = (1.0 - strength) * m_Strength;
								}

							coords2[0] += strength * gridpoint.m_DX;
							coords2[1] += strength * gridpoint.m_DY;
							coords2[2] += strength * gridpoint.m_DZ;
						}
					m_PointLocation->SetLocalXYZ(coords2);
				}
		}
	else if(MAGNETS == m_Type)
		{
			// Calculate & store grid point locations
			for(position1 = m_GridPoints.GetHeadPosition(); position1; m_GridPoints.GetNext(position1))
				{
					gridpoint = m_GridPoints.GetAt(position1);

					m_PointList->SetHandle(gridpoint.m_PointHandle);
					m_PointLocation->GetLocalXYZ(coords1);
					gridpoint.m_DX = coords1[0];
					gridpoint.m_DY = coords1[1];
					gridpoint.m_DZ = coords1[2];

					m_GridPoints.GetAt(position1) = gridpoint;
				}

			// Enumerate active points
			for(position2 = m_ActivePoints.GetHeadPosition(); position2; m_ActivePoints.GetNext(position2))
				{
					activepoint = m_ActivePoints.GetAt(position2);
					coords2[0] = activepoint.m_OriginalX;
					coords2[1] = activepoint.m_OriginalY;
					coords2[2] = activepoint.m_OriginalZ;

					m_PointList->SetHandle(m_ActivePoints.GetAt(position2).m_PointHandle);

					// Enumerate grid points
					for(position1 = m_GridPoints.GetHeadPosition(); position1; m_GridPoints.GetNext(position1))
						{
							gridpoint = m_GridPoints.GetAt(position1);

							distx = gridpoint.m_DX - coords2[0];
							disty = gridpoint.m_DY - coords2[1];
							distz = gridpoint.m_DZ - coords2[2];

							dist = distx * distx + disty * disty + distz * distz;
							if(dist > range) continue;

							strength = sqrt(dist) / m_Range;
							if(m_CustomStrength)
								{
									strength = m_Strengthfalloff->GetValue1(strength, .001) * m_Strength;
								}
							else
								{
									strength = (1.0 - strength) * m_Strength;
								}

							coords2[0] += strength * distx;
							coords2[1] += strength * disty;
							coords2[2] += strength * distz;
						}
					m_PointLocation->SetLocalXYZ(coords2);
				}
		}
}




void CFFDeform::OnReset()
{
	POSITION position;
	double coords[3];

	SFFDeformActivePoint activepoint;
	SFFDeformGridPoint gridpoint;

	// Reset grid points
	for(position = m_GridPoints.GetHeadPosition(); position; m_GridPoints.GetNext(position))
		{
			gridpoint = m_GridPoints.GetAt(position);

			coords[0] = gridpoint.m_OriginalX;
			coords[1] = gridpoint.m_OriginalY;
			coords[2] = gridpoint.m_OriginalZ;

			m_PointList->SetHandle(gridpoint.m_PointHandle);
			m_PointLocation->SetOldXYZ(coords);
			m_PointLocation->SetLocalXYZ(coords);
		}

	// Reset active points
	for(position = m_ActivePoints.GetHeadPosition(); position; m_ActivePoints.GetNext(position))
		{
			activepoint = m_ActivePoints.GetAt(position);

			coords[0] = activepoint.m_OriginalX;
			coords[1] = activepoint.m_OriginalY;
			coords[2] = activepoint.m_OriginalZ;

			m_PointList->SetHandle(activepoint.m_PointHandle);
			m_PointLocation->SetOldXYZ(coords);
			m_PointLocation->SetLocalXYZ(coords);
		}
}


void CFFDeform::OnSet()
{
	POSITION position;
	double coords[3];

	SFFDeformActivePoint activepoint;
	SFFDeformGridPoint gridpoint;

	if(SDP_S_OK == m_IO->Query("Make all changes to grid and active points permanent? (No Undo)", "FFDeform:"))
		{
			// Reset grid points
			for(position = m_GridPoints.GetHeadPosition(); position; m_GridPoints.GetNext(position))
				{
					gridpoint = m_GridPoints.GetAt(position);
					m_PointList->SetHandle(gridpoint.m_PointHandle);

					m_PointLocation->GetLocalXYZ(coords);
					m_PointLocation->SetOldXYZ(coords);

					gridpoint.m_OriginalX = coords[0];
					gridpoint.m_OriginalY = coords[1];
					gridpoint.m_OriginalZ = coords[2];

					m_GridPoints.GetAt(position) = gridpoint;
				}

			// Reset active points
			for(position = m_ActivePoints.GetHeadPosition(); position; m_ActivePoints.GetNext(position))
				{
					activepoint = m_ActivePoints.GetAt(position);
					m_PointList->SetHandle(activepoint.m_PointHandle);

					m_PointLocation->GetLocalXYZ(coords);
					m_PointLocation->SetOldXYZ(coords);

					activepoint.m_OriginalX = coords[0];
					activepoint.m_OriginalY = coords[1];
					activepoint.m_OriginalZ = coords[2];

					m_ActivePoints.GetAt(position) = activepoint;
				}
		}

	k3dTool::OnSet();
}




