
#include "resource.h"


struct SFFDeformGridPoint {

	HANDLE m_PointHandle;
	double m_OriginalX;
	double m_OriginalY;
	double m_OriginalZ;
	double m_DX;
	double m_DY;
	double m_DZ;

	};


struct SFFDeformActivePoint {

	HANDLE m_PointHandle;
	double m_OriginalX;
	double m_OriginalY;
	double m_OriginalZ;

	};



// Forward declaration
class CFFDeform;
class CFFDeformSheet;



/////////////////////////////////////////////////////////////////////////////
// CFFDeformPage dialog

class CFFDeformPage : public KPage
{
public:
	CFFDeformPage(CFFDeformSheet* Sheet);

	void OnUpdateNumbers();

	CFFDeformSheet* m_Sheet;

	//{{AFX_DATA(CFFDeformPage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CFFDeformPage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CFFDeformPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnActiveadd();
	afx_msg void OnActiveremove();
	afx_msg void OnActiveremoveall();
	afx_msg void OnActiveselect();
	afx_msg void OnGridadd();
	afx_msg void OnGridremove();
	afx_msg void OnGridremoveall();
	afx_msg void OnGridselect();
	afx_msg void OnBones();
	afx_msg void OnMagnets();
	afx_msg void OnKillfocusRange();
	afx_msg void OnKillfocusStrength();
	afx_msg void OnReset();
	afx_msg void OnUpdate();
	afx_msg void OnCustomstrength();
	afx_msg void OnAutoupdate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CFFDeformSheet

class CFFDeformSheet : public KSheet
{
public:
	CFFDeformSheet(CFFDeform* Object);
	~CFFDeformSheet();

	bool Create();
	void OnHelp();

	CFFDeform* m_Object;

	CFFDeformPage* m_FFDeformPage;

	//{{AFX_DATA(CFFDeformSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CFFDeformSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CFFDeformSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




 

class CFFDeform : public k3dTool,
									public KAnimate

{
public:
	CFFDeform();
	~CFFDeform();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	// k3dIObject overrides
	sdpResult SetObjectContext(k3dIApplication* Server, k3dIObjectContext*);
	sdpResult EditObject();

	// k3dIDocumentEventClient overrides
	sdpResult OnUndo(k3dIObject*);
	sdpResult OnPointsDeparting();
	sdpResult OnPolygonsDeparting();

	// k3dIAnimate overrides
	sdpResult PostAnimate();


	CFFDeformSheet* m_Sheet;

	CList<SFFDeformActivePoint, SFFDeformActivePoint> m_ActivePoints;
	CList<SFFDeformGridPoint, SFFDeformGridPoint> m_GridPoints;
	CList<KHANDLE, KHANDLE> m_GridPolys;

	KObjectContainer<&sdpChannel, &IID_k3dIChannel, k3dIChannel> m_Strengthfalloff;

	typedef enum
	{
		BONES,
		MAGNETS,
	} Type;

	double m_Strength;
	double m_Range;
	Type m_Type;

	bool m_CustomStrength;
	bool m_AutoUpdate;


	void OnModify();
	void OnModifyGeometry();
	void OnReset();
	void OnSet();
};






