
#include "resource.h"


// Forward declarations
class CJoinPolys;
class CJoinPolysSheet;



/////////////////////////////////////////////////////////////////////////////
// CJoinPolysPage dialog

class CJoinPolysPage : public KPage
{
public:
	CJoinPolysPage(CJoinPolysSheet* Sheet);

	CJoinPolysSheet* m_Sheet;

	//{{AFX_DATA(CJoinPolysPage)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CJoinPolysPage)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CJoinPolysPage)
	virtual BOOL OnInitDialog();
	afx_msg void On2Point();
	afx_msg void On4Point();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CJoinPolysSheet

class CJoinPolysSheet : public KPrimSheet
{
public:
	CJoinPolysSheet(CJoinPolys* Object);
	~CJoinPolysSheet();

	bool Create();
	void OnHelp();

	CJoinPolys* m_Object;

	CJoinPolysPage* m_JoinPolysPage;

	//{{AFX_DATA(CJoinPolysSheet)
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CJoinPolysSheet)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CJoinPolysSheet)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};







/////////////////////////////////////////////////////////////////////////////
// CJoinPolys

class CJoinPolys : public k3dPrimTool,
									 public k3dOpenGLRender
{
public:
	CJoinPolys();
	~CJoinPolys();

	// k3dIUnknown overrides
	sdpResult QueryInterface(const sdpIID& InterfaceID, void** Interface);
	gulong AddRef();
	gulong Release();

	//k3dIObject overrides
	sdpResult SetObjectContext(k3dIApplication* Server, k3dIObjectContext* Context);
	sdpResult EditObject();

	//k3dIDocumentEventClient overrides
	sdpResult OnUndo(k3dIObject*);
	
	// k3dIUserEventClient overrides
	sdpResult OnLButtonClick(long, long, long);

	// k3dIOpenGLRender overrides
	sdpResult OpenGLRender(k3dICamera* Camera, k3dIOpenGLEngine* Engine);


	CJoinPolysSheet* m_Sheet;

	typedef enum
	{
		TWOPOINT,
		FOURPOINT,
	} Type;

	Type m_JoinType;
	KHANDLE m_Point1;
	KHANDLE m_Point2;
	KHANDLE m_Point3;
	KHANDLE m_Point4;
	KHANDLE m_Polygon1;
	KHANDLE m_Polygon2;

	gulong m_Group;

	bool Create();
	void OnModify();
	void CreatePolygon();
	void OnReset();

};

