#include "stdafx.h"
#include "tlbselectsimilar.h"
#include "toollib.h"




CSelectSimilarDialog::CSelectSimilarDialog(CSelectSimilar* Object)
	: k3dDialog(Object, theApp.m_hInstance, "SelectSimilar - Selects / deselects polygons based on their similarity to the current Active Polygon", VERTICAL, "SelectSimilar", TRUE)
{
	//{{AFX_DATA_INIT(CSelectSimilarDialog)
	//}}AFX_DATA_INIT

	m_Object = Object;
}


CSelectSimilarDialog::~CSelectSimilarDialog()
{
	m_Object->m_Dialog = NULL;
}


bool CSelectSimilarDialog::Create()
{
	Create(IDD);
	return TRUE;
}



void CSelectSimilarDialog::OnHelp()
{
	m_Object->StandardHelp("tools", "selectsimilar.html");
}


BEGIN_MESSAGE_MAP(CSelectSimilarDialog, k3dDialog)
	//{{AFX_MSG_MAP(CSelectSimilarDialog)
	ON_BN_CLICKED(IDC_3SIDED, On3sided)
	ON_BN_CLICKED(IDC_4SIDES, On4sides)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_GT3SIDES, OnGt3sides)
	ON_BN_CLICKED(IDC_GT4SIDES, OnGt4sides)
	ON_BN_CLICKED(IDC_MATERIAL, OnMaterial)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_BN_CLICKED(IDC_SHADING, OnShading)
	ON_BN_CLICKED(IDC_SIDES, OnSides)
	ON_BN_CLICKED(IDC_SUBTRACT, OnSubtract)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSelectSimilarDialog message handlers


BOOL CSelectSimilarDialog::OnInitDialog()
{
	k3dDialog::OnInitDialog();

	CheckDlgButton(IDC_MATERIAL, m_Object->m_Material);
	CheckDlgButton(IDC_SHADING, m_Object->m_Shading);
	CheckDlgButton(IDC_SIDES, m_Object->m_Sides);
	CheckDlgButton(IDC_3SIDED, m_Object->m_3Sided);
	CheckDlgButton(IDC_GT3SIDES, m_Object->m_GT3Sided);
	CheckDlgButton(IDC_4SIDES, m_Object->m_4Sided);
	CheckDlgButton(IDC_GT4SIDES, m_Object->m_GT4Sided);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CSelectSimilarDialog::On3sided()
{
	m_Object->m_3Sided = IsDlgButtonChecked(IDC_3SIDED) ? TRUE : FALSE;
	m_Object->m_4Sided = FALSE;
	m_Object->m_GT3Sided = FALSE;
	m_Object->m_GT4Sided = FALSE;
	CheckDlgButton(IDC_GT3SIDES, m_Object->m_GT3Sided);
	CheckDlgButton(IDC_4SIDES, m_Object->m_4Sided);
	CheckDlgButton(IDC_GT4SIDES, m_Object->m_GT4Sided);

}

void CSelectSimilarDialog::On4sides()
{
	m_Object->m_4Sided = IsDlgButtonChecked(IDC_4SIDES) ? TRUE : FALSE;
	m_Object->m_3Sided = FALSE;
	m_Object->m_GT3Sided = FALSE;
	m_Object->m_GT4Sided = FALSE;
	CheckDlgButton(IDC_3SIDED, m_Object->m_3Sided);
	CheckDlgButton(IDC_GT3SIDES, m_Object->m_GT3Sided);
	CheckDlgButton(IDC_GT4SIDES, m_Object->m_GT4Sided);
}

void CSelectSimilarDialog::OnGt3sides()
{
	m_Object->m_GT3Sided = IsDlgButtonChecked(IDC_GT3SIDES) ? TRUE : FALSE;
	m_Object->m_3Sided = FALSE;
	m_Object->m_4Sided = FALSE;
	m_Object->m_GT4Sided = FALSE;
	CheckDlgButton(IDC_3SIDED, m_Object->m_3Sided);
	CheckDlgButton(IDC_4SIDES, m_Object->m_4Sided);
	CheckDlgButton(IDC_GT4SIDES, m_Object->m_GT4Sided);
}

void CSelectSimilarDialog::OnGt4sides()
{
	m_Object->m_GT4Sided = IsDlgButtonChecked(IDC_GT4SIDES) ? TRUE : FALSE;
	m_Object->m_3Sided = FALSE;
	m_Object->m_4Sided = FALSE;
	m_Object->m_GT3Sided = FALSE;
	CheckDlgButton(IDC_3SIDED, m_Object->m_3Sided);
	CheckDlgButton(IDC_GT3SIDES, m_Object->m_GT3Sided);
	CheckDlgButton(IDC_4SIDES, m_Object->m_4Sided);
}

void CSelectSimilarDialog::OnMaterial()
{
	m_Object->m_Material = IsDlgButtonChecked(IDC_MATERIAL) ? TRUE : FALSE;
}


void CSelectSimilarDialog::OnShading()
{
	m_Object->m_Shading = IsDlgButtonChecked(IDC_SHADING) ? TRUE : FALSE;
}

void CSelectSimilarDialog::OnSides()
{
	m_Object->m_Sides = IsDlgButtonChecked(IDC_SIDES) ? TRUE : FALSE;
}

void CSelectSimilarDialog::OnSelect()
{
	m_Object->OnSelect();
	OnModify();
}

void CSelectSimilarDialog::OnAdd()
{
	m_Object->OnAdd();
	OnModify();
}

void CSelectSimilarDialog::OnSubtract()
{
	m_Object->OnSubtract();
	OnModify();
}


/////////////////////////////////////////////////////////////////////////////////
// CSelectSimilar


CSelectSimilar::CSelectSimilar() : k3dTool()
{
	m_Material = FALSE;
	m_Shading = FALSE;
	m_Sides = FALSE;
	m_3Sided = FALSE;
	m_GT3Sided = FALSE;
	m_4Sided = FALSE;
	m_GT4Sided = FALSE;

	m_Dialog = NULL;
}


CSelectSimilar::~CSelectSimilar()
{
	if(m_Dialog) m_Dialog->DestroyWindow();
}


///////////////////////////////////////////////////////////////
// k3dIUnknown overrides

sdpResult CSelectSimilar::QueryInterface(const sdpIID& InterfaceID, void** Interface)
{
	if(sdpSupportInterface<sdpIUnknown>(static_cast<k3dIObject*>(this), InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIObject>(this, InterfaceID, Interface)) return SDP_S_OK;

	if(sdpSupportInterface<k3dIDocumentEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIUserEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	if(sdpSupportInterface<k3dIEventClient>(this, InterfaceID, Interface)) return SDP_S_OK;
	return SDP_E_NO_INTERFACE;
}


gulong CSelectSimilar::AddRef()
{
	return sdpComAddRef(m_ReferenceCount);
}


gulong CSelectSimilar::Release()
{
	return sdpComRelease(this, m_ReferenceCount);
}



///////////////////////////////////////////////////////////////
// k3dIObject overrides

sdpResult CSelectSimilar::EditObject()
{
	if(!KOpenDialog(m_Dialog, this)) KFAIL(SDP_E_FAIL);
	return SDP_S_OK;
}



/////////////////////////////////////////////////////////////////////////////
// CSelectSimilar message handlers

void CSelectSimilar::SelectSimilar(bool State)
{
	// Get data about the active polygon ...
	gulong activepoints = 0;
	k3dIMaterial* activematerial = NULL;

	k3dIPolygon* activepoly = m_Document->GetActivePolygon();
	if(activepoly)
		{
			activepoints = activepoly->Points()->GetPointCount();
			activematerial = activepoly->Material()->GetMaterial();
		}

	// Iterate all polygons in the document ...
	for(k3dIPolygon* poly = m_Document->GetFirstPolygon(); poly; poly = m_Document->GetNextPolygon(poly))
		{
			// Skip hidden and unselectable polys ...
			if(SDP_S_OK != poly->State()->QueryState(k3dIState::VISIBLE | k3dIState::SELECTABLE)) continue;

			gulong numpoints = poly->Points()->GetPointCount();

			// Skip if materials don't match ...
			if(m_Material && activepoly && (activematerial != poly->Material()->GetMaterial())) continue;

			// Skip if the number of sides don't match ...
			if(m_Sides && activepoly && (activepoints != numpoints)) continue;

			// Specific numbers of sides ...
			if(m_3Sided && (3 != numpoints)) continue;
			if(m_GT3Sided && (numpoints <= 3)) continue;
			if(m_4Sided && (4 != numpoints)) continue;
			if(m_GT4Sided && (numpoints <= 4)) continue;

			poly->State()->SetState(k3dIState::SELECTED, State);
		}
}

void CSelectSimilar::OnSelect()
{
	for(k3dIPolygon* poly = m_Document->GetFirstPolygon(); poly; poly = m_Document->GetNextPolygon(poly))
		{
			poly->State()->SetState(k3dIState::SELECTED, FALSE);
		}
	OnAdd();
}

void CSelectSimilar::OnAdd()
{
	SelectSimilar(TRUE);
}

void CSelectSimilar::OnSubtract()
{
	SelectSimilar(FALSE);
}

