#ifndef SDPGTKUTILITY_H
#define SDPGTKUTILITY_H

// SDPGTK Library
// Copyright  1995 - 2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <gtk/gtk.h>
#include <sdpsimpletypes.h>

// Forward class declarations
class sdpXmlIElement;

/// Marks a GTKML (XML) attribute as "used", so we can warn about unused & unknown attributes when loading documents
void sdpGtkMarkAttribute(sdpXmlIElement* Element, SDPCSTRING Attribute);
/// Looks for a "shadowtype" attribute in a GTKML (XML) document and returns its value
GtkShadowType sdpGtkGetShadowType(GtkShadowType Default, sdpXmlIElement* Element);

/// Dispatches any pending GTK+ events (good to do after any long operations)
void sdpGtkHandlePendingEvents();

#endif // SDPGTKUTILITY_H
