
// SDPGTK Library
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



#include <sdpgtkcolorselection.h>


////////////////////////////////////////////////////////////////////////////////////////
// sdpGtkColorSelection

sdpGtkColorSelection::sdpGtkColorSelection() : sdpGtkVBox()
{
}

sdpGtkColorSelection::sdpGtkColorSelection(GtkColorSelection* ColorSelection) : sdpGtkVBox(GTK_VBOX(ColorSelection))
{
}

bool sdpGtkColorSelection::Create()
{
	m_Object = GTK_OBJECT(gtk_color_selection_new());
	return Attached();
}

bool sdpGtkColorSelection::Create(sdpGtkIObjectContainer* ObjectContainer, sdpXmlIElement* Element)
{
	// Sanity checks ...
	g_assert(ObjectContainer);
	g_assert(Element);

	return Create();
}

void sdpGtkColorSelection::SetUpdatePolicy(GtkUpdateType Policy)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(m_Object), Policy);
}

void sdpGtkColorSelection::SetOpacity(bool UseOpacity)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	gtk_color_selection_set_opacity(GTK_COLOR_SELECTION(m_Object), UseOpacity);
}

void sdpGtkColorSelection::SetColor(gdouble* Color)
{
	// Sanity checks ...
	g_return_if_fail(Attached());
	g_assert(Color);

	gtk_color_selection_set_color(GTK_COLOR_SELECTION(m_Object), Color);
}

void sdpGtkColorSelection::GetColor(gdouble* Color)
{
	// Sanity checks ...
	g_return_if_fail(Attached());
	g_assert(Color);

	gtk_color_selection_get_color(GTK_COLOR_SELECTION(m_Object), Color);
}


