
// SDPGTK Library
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



#include <sdpgtkcontainer.h>

sdpGtkContainer::sdpGtkContainer() : sdpGtkWidget()
{
}

sdpGtkContainer::sdpGtkContainer(GtkContainer* Container) : sdpGtkWidget(GTK_WIDGET(Container))
{
}

void sdpGtkContainer::Attach(GtkWidget* Widget)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	gtk_container_add(GTK_CONTAINER(m_Object), Widget);
}

void sdpGtkContainer::Attach(sdpGtkWidget& Widget)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	Attach((GtkWidget*)Widget);
}

void sdpGtkContainer::Remove(GtkWidget* Widget)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	gtk_container_remove(GTK_CONTAINER(m_Object), Widget);
}

void sdpGtkContainer::Remove(sdpGtkWidget& Widget)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	Remove((GtkWidget*)Widget);
}

void sdpGtkContainer::SetBorderWidth(guint BorderWidth)
{
	// Sanity checks ...
	g_return_if_fail(Attached());

	gtk_container_set_border_width(GTK_CONTAINER(m_Object), BorderWidth);
}

bool sdpGtkContainer::AttachChild(sdpGtkIObjectContainer* ObjectContainer, sdpXmlIElement* ChildElement, sdpGtkObject* Child)
{
	// Sanity checks ...
	g_return_val_if_fail(Attached(), false);

	g_assert(ChildElement);
	g_assert(Child);

	Attach(GTK_WIDGET(Child->Object()));

	return true;
}
