#include <sdpgtkloopevents.h>

///////////////////////////////////////////////////////////////////////////////
// sdpGtkEventQuit ('quit')

sdpGtkEventQuit::sdpGtkEventQuit(SDPCSTRING EventType, SDPCSTRING EventName, sdpGtkObjectContainer* EventContainer) : 
	sdpGtkLoopEvent(EventType, EventName, EventContainer)
{
	// By default, the event should only be called once ...
	m_Result = false;
}

void sdpGtkEventQuit::Connect()
{
  m_EventHandler = gtk_quit_add(gtk_main_level(), RawEvent, gpointer(this));
}

void sdpGtkEventQuit::Disconnect()
{
	// Sanity checks ...
	g_assert(m_EventHandler);

	gtk_quit_remove(m_EventHandler);
	m_EventHandler = 0;
}

///////////////////////////////////////////////////////////////////////////////
// sdpGtkEventTimeout ('timeout')

sdpGtkEventTimeout::sdpGtkEventTimeout(SDPCSTRING EventType, SDPCSTRING EventName, sdpGtkObjectContainer* EventContainer) : 
	sdpGtkLoopEvent(EventType, EventName, EventContainer)
{
	// By default, the event should be called indefinitely ...
	m_Result = true;
	m_Duration = 0;
}

void sdpGtkEventTimeout::Connect()
{
  m_EventHandler = gtk_timeout_add(m_Duration, RawEvent, gpointer(this));
}

void sdpGtkEventTimeout::Disconnect()
{
	// Sanity checks ...
	g_assert(m_EventHandler);

	gtk_timeout_remove(m_EventHandler);
	m_EventHandler = 0;
}

gulong sdpGtkEventTimeout::Duration()
{
	return m_Duration;
}

void sdpGtkEventTimeout::SetDuration(gulong Duration)
{
	m_Duration = Duration;
}

///////////////////////////////////////////////////////////////////////////////
// sdpGtkEventIdle ('idle')

sdpGtkEventIdle::sdpGtkEventIdle(SDPCSTRING EventType, SDPCSTRING EventName, sdpGtkObjectContainer* EventContainer) : 
	sdpGtkLoopEvent(EventType, EventName, EventContainer)
{
	// By default, the event should be called indefinitely ...
	m_Result = true;
}

void sdpGtkEventIdle::Connect()
{
  m_EventHandler = gtk_idle_add(RawEvent, gpointer(this));
}

void sdpGtkEventIdle::Disconnect()
{
	// Sanity checks ...
	g_assert(m_EventHandler);

	gtk_idle_remove(m_EventHandler);
	m_EventHandler = 0;
}

