// K-3D
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Implements the regextest command-line application, used to test SDPTYPES' regular-expression wrappers
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpregex.h>
#include <iostream>

int main(int argc, char* argv[])
{
	if(argc != 3)
		{
			std::cout << "Usage: regextest [regular expression] [string]" << std::endl;
			return 0;
		}

	std::cout << "searching for " << argv[1] << " within " << argv[2] << " (case sensitive)" << std::endl;

	sdpRegEx re;
	if(!re.Create(argv[1], true))
		{
			std::cerr << "Error compiling regular expression " << argv[1] << std::endl;
			return 1;
		}
	
	sdpRegExMatchArray subexpressions;	
	re.Search(argv[2], subexpressions);
	
	for(sdpRegExMatchIterator match = subexpressions.begin(); match != subexpressions.end(); match++)
		std::cout << match->first << " - " << match->second << std::endl;
	
	return 0;
}

