
// SDPTypes Library
// Copyright  1995-2000, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


/** \file
		\brief Implements the sdpUserData class which implements the sdpIUserData interface
		\author Tim Shead (tshead@k-3d.com)
*/

#include <sdpuserdata.h>

// sdpIUserData overrides ...
sdpResult sdpUserData::SetData(SDPCSTRING Name, SDPCSTRING Value)
{
	// Sanity checks ...
	g_return_val_if_string_fail(Name, SDP_E_FAIL);

	m_UserData[Name] = Value;

	return SDP_S_OK;
}


SDPCSTRING sdpUserData::GetData(SDPCSTRING Name) const
{
	// Sanity checks ...
	g_return_val_if_string_fail(Name, 0);

	ConstUserDataIterator i = m_UserData.find(Name);
	if(i != m_UserData.end())
		return (*i).second;
	
	return "";
}
